## vmpk-dmo 0.8.4

=== CMakeLists.txt ===
# Virtual MIDI Piano Keyboard
# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.14)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.12" CACHE STRING "Minimum OS X deployment version")

project( VMPK
    VERSION 0.8.4
    LANGUAGES CXX
    DESCRIPTION "Virtual MIDI Piano Keyboard"
    HOMEPAGE_URL "https://vmpk.sourceforge.io/"
)

set(DBUS_INIT OFF)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    set(DBUS_INIT ON)
endif()
option(ENABLE_DBUS "Enable VMPK DBus interface" ${DBUS_INIT})
option(EMBED_TRANSLATIONS "Embed translations instead of installing" OFF)
option(BUILD_DOCS "Build man page" ON)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_admin")
include(SCMRevision)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# cmake bug https://gitlab.kitware.com/cmake/cmake/issues/18396 closed in cmake 3.14
if(APPLE AND ${CMAKE_VERSION} VERSION_LESS 3.14)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra") #-Wzero-as-null-pointer-constant -Wsuggest-override
endif()
#if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Wall")
#endif()

# CMAKE_SYSTEM_PROCESSOR is broken on Windows with MSVC
# cmake bug https://gitlab.kitware.com/cmake/cmake/-/issues/15170 still open in 2021/03
if(MSVC)
    string(TOLOWER ${MSVC_CXX_ARCHITECTURE_ID} CMAKE_SYSTEM_PROCESSOR)
endif()

find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets Network LinguistTools REQUIRED)
find_package(Drumstick 2.3 COMPONENTS RT Widgets REQUIRED)
if (QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
    find_package(Qt6 COMPONENTS Core5Compat REQUIRED)
endif()

message (STATUS "VMPK v${PROJECT_VERSION}
     install prefix: ${CMAKE_INSTALL_PREFIX}
     Build configuration: ${CMAKE_BUILD_TYPE}
     Operating System: ${CMAKE_SYSTEM_NAME}
     System Processor: ${CMAKE_SYSTEM_PROCESSOR}
     D-Bus support: ${ENABLE_DBUS}
     Qt5 Version: ${Qt5_VERSION}
     Drumstick Version: ${Drumstick_VERSION}"
)

if (ENABLE_DBUS)
    find_package(Qt${QT_VERSION_MAJOR}DBus REQUIRED)
endif ()

if (UNIX AND NOT APPLE)
    find_package(Qt${QT_VERSION_MAJOR}X11Extras REQUIRED)
    find_package(PkgConfig REQUIRED)
    if(PKG_CONFIG_FOUND)
        message(STATUS "Program pkg-config v${PKG_CONFIG_VERSION_STRING} found (${PKG_CONFIG_EXECUTABLE})")
    else()
        message(FATAL_ERROR "Program pkg-config not found")
    endif()
    pkg_check_modules(XCB REQUIRED xcb)
    if(XCB_FOUND)
        message(STATUS "Found XCB development libs v${XCB_VERSION}")
    endif()
    include(GNUInstallDirs)
endif()

add_subdirectory(src)
if (NOT EMBED_TRANSLATIONS)
    add_subdirectory(translations)
endif()

set(vmpk_DATA_FILES
    data/gmgsxg.ins
    data/help.html
    data/help_es.html
    data/help_ru.html
    data/help_sr.html
    data/azerty.xml
    data/german.xml
    data/it-qwerty.xml
    data/pc102mac.xml
    data/pc102win.xml
    data/pc102x11.xml
    data/Serbian-cyr.xml
    data/Serbian-lat.xml
    data/spanish.xml
    data/vkeybd-default.xml
    data/txt2ins.awk
)

#unmaintained or deprecated data files:
    #data/hm.html
    #data/hm_es.html
    #data/hm_ru.html
    #data/help_de.html
    #data/help_fr.html
    #data/help_nl.html

if(UNIX)
    add_custom_target (tarball
        COMMAND mkdir -p vmpk-${PROJECT_VERSION}/translations/
        COMMAND cp -r cmake_admin vmpk-${PROJECT_VERSION}
        COMMAND cp -r data vmpk-${PROJECT_VERSION}
        COMMAND cp -r src vmpk-${PROJECT_VERSION}
        COMMAND cp -r man vmpk-${PROJECT_VERSION}
        COMMAND cp -r dbus vmpk-${PROJECT_VERSION}
        COMMAND cp translations/vmpk_{cs,de,es,fr,gl,ru,sr,sv}.ts vmpk-${PROJECT_VERSION}/translations/
        COMMAND cp translations/CMakeLists.txt vmpk-${PROJECT_VERSION}/translations/
        COMMAND cp AUTHORS ChangeLog CMakeLists.txt COPYING gpl.rtf NEWS README.md TODO *.nsi *.nsi.in net.sourceforge.VMPK.desktop net.sourceforge.VMPK.appdata.xml vmpk.pro *.pri vmpk.spec.in qt.conf vmpk-${PROJECT_VERSION}
        COMMAND tar -cj --exclude=.* -f vmpk-${PROJECT_VERSION}.tar.bz2 vmpk-${PROJECT_VERSION}
        COMMAND tar -cz --exclude=.* -f vmpk-${PROJECT_VERSION}.tar.gz vmpk-${PROJECT_VERSION}
        COMMAND zip -qr vmpk-${PROJECT_VERSION}.zip vmpk-${PROJECT_VERSION} -x '.[a-z]*'
        COMMAND rm -rf vmpk-${PROJECT_VERSION}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )
endif ()

if(UNIX AND NOT APPLE)
    configure_file ( vmpk.spec.in
        ${CMAKE_CURRENT_BINARY_DIR}/vmpk.spec
        IMMEDIATE @ONLY )
    add_subdirectory (man)

    install (FILES ${vmpk_DATA_FILES}
             DESTINATION ${CMAKE_INSTALL_DATADIR}/vmpk )

    install (FILES data/vmpk_16x16.png
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/16x16/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_32x32.png
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_48x48.png
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_64x64.png
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps
             RENAME vmpk.png)

    install (FILES data/vmpk_128x128.png
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps
             RENAME vmpk.png)

    install (FILES data/vmpk.svgz
             DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps )

    install (FILES net.sourceforge.VMPK.desktop
             DESTINATION ${CMAKE_INSTALL_DATADIR}/applications )

    install (FILES net.sourceforge.VMPK.appdata.xml
             DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo )

     # uninstall custom target
     configure_file(
         "${CMAKE_SOURCE_DIR}/cmake_admin/cmake_uninstall.cmake.in"
         "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
         IMMEDIATE @ONLY)
     add_custom_target( uninstall
         "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif ()

if(WIN32)
    include (InstallRequiredSystemLibraries)
	install (FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS} 
			 DESTINATION .)
    install (FILES ${vmpk_DATA_FILES}
             DESTINATION .)
	set(FLUIDSYNTH_PREFIX $ENV{FLUIDSYNTH})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup-msvc2019.nsi.in
        ${CMAKE_CURRENT_BINARY_DIR}/setup-msvc2019.nsi IMMEDIATE @ONLY)
endif()

# CPack support
include (InstallRequiredSystemLibraries)
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Virtual MIDI Piano Keyboard")
set (CPACK_PACKAGE_VENDOR "vmpk.sourceforge.net")
set (CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/gpl.rtf")
set (CPACK_PACKAGE_VERSION_MAJOR ${CMAKE_PROJECT_VERSION_MAJOR})
set (CPACK_PACKAGE_VERSION_MINOR ${CMAKE_PROJECT_VERSION_MINOR})
set (CPACK_PACKAGE_VERSION_PATCH ${CMAKE_PROJECT_VERSION_PATCH})
set (CPACK_PACKAGE_INSTALL_DIRECTORY "vmpk")
set (CPACK_PACKAGE_EXECUTABLES "vmpk" "Virtual MIDI Piano Keyboard")

# source packages
set (CPACK_SOURCE_GENERATOR TGZ;TBZ2;ZIP)
set (CPACK_SOURCE_IGNORE_FILES "/.svn/;/build/;/share/;~$;.cproject;.project;.user;${CPACK_SOURCE_IGNORE_FILES}")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "vmpk-${PROJECT_VERSION}")
set (CPACK_SOURCE_STRIP_FILES OFF)

# linux binary packages
if (${CMAKE_SYSTEM} MATCHES "Linux")
    set (CPACK_GENERATOR TGZ;TBZ2)
    set (CPACK_PACKAGE_NAME "vmpk")
    set (CPACK_SYSTEM_NAME ${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR})
#   set (CPACK_INCLUDE_TOPLEVEL_DIRECTORY 0)
#   set (CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
    set (CPACK_STRIP_FILES ON)
endif ()

# Windows NSIS setup package
#if (WIN32)
#    set (CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/src/vmpk.ico")
#    set (CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\MyExecutable.exe")
#    set (CPACK_NSIS_DISPLAY_NAME "Virtual MIDI Piano Keyboard")
#    set (CPACK_NSIS_HELP_LINK "http://vmpk.sourceforge.net")
#    set (CPACK_NSIS_URL_INFO_ABOUT "http://vmpk.sourceforge.net")
#    set (CPACK_NSIS_CONTACT "plcl@users.sourceforge.net")
#    set (CPACK_NSIS_MODIFY_PATH OFF)
#endif ()

include (CPack)

=== src/CMakeLists.txt ===
# Virtual MIDI Piano Keyboard
# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along 
# with this program; If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if (EMBED_TRANSLATIONS)
    set( TRANSLATIONS
         ../translations/vmpk_cs.ts
         ../translations/vmpk_de.ts
         ../translations/vmpk_es.ts
         ../translations/vmpk_fr.ts
         ../translations/vmpk_gl.ts
         ../translations/vmpk_ru.ts
         ../translations/vmpk_sr.ts
         ../translations/vmpk_sv.ts
    )
    if (QT_VERSION VERSION_LESS 5.15.0)
        qt5_add_translation(QM_FILES ${TRANSLATIONS})
    else()
        qt_add_translation(QM_FILES ${TRANSLATIONS})
    endif()
    include(TranslationUtils)
    get_target_property(DRUMSTICK_LOCATION Drumstick::Widgets INTERFACE_INCLUDE_DIRECTORIES)
    get_filename_component(DRUMSTICK_PREFIX ${DRUMSTICK_LOCATION} DIRECTORY)
    file(GLOB WIDGETS_TRANS "${DRUMSTICK_PREFIX}/share/drumstick/drumstick-widgets_*.qm")
    file(COPY ${WIDGETS_TRANS} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    add_app_translations_resource(APP_RES ${QM_FILES} ${WIDGETS_TRANS})
    add_qt_translations_resource(QT_RES cs de es fr gl ru sr sv)
endif()

set(vmpk_SRCS
    about.ui
    colordialog.ui
    extracontrols.ui
    kmapdialog.ui
    midisetup.ui
    preferences.ui
    riffimportdlg.ui
    vpiano.ui
    shortcutdialog.ui
    about.cpp
    about.h
    colordialog.cpp
    colordialog.h
    colorwidget.cpp
    colorwidget.h
    constants.h
    extracontrols.cpp
    extracontrols.h
    instrument.cpp
    instrument.h
    keyboardmap.cpp
    keyboardmap.h
    kmapdialog.cpp
    kmapdialog.h
    maceventhelper.h
    main.cpp
    mididefs.h
    midisetup.cpp
    midisetup.h
    preferences.cpp
    preferences.h
    nativefilter.cpp
    nativefilter.h
    riff.cpp
    riff.h
    riffimportdlg.cpp
    riffimportdlg.h
    shortcutdialog.cpp
    shortcutdialog.h
    vpiano.cpp
    vpiano.h
    vpianosettings.cpp
    vpianosettings.h
    ../data/vmpk.qrc
    ${APP_RES}
    ${QT_RES}
)

if(WIN32)
    include(CheckCXXSourceCompiles)
    check_cxx_source_compiles("#include <Windows.h>
        int main() { EnumWindows([](HWND, LPARAM) -> BOOL { return true; }, 0); return 0; }"
        COMPILER_SUPPORTED)
    if (NOT COMPILER_SUPPORTED)
        message(FATAL_ERROR "Sorry, your compiler is not supported: ${CMAKE_CXX_COMPILER}")
    endif()
    list(APPEND vmpk_SRCS winsnap.cpp winsnap.h)
endif()

if(ENABLE_DBUS)
    add_definitions(-DENABLE_DBUS)
    if (QT_VERSION VERSION_LESS 5.15.0)
        qt5_add_dbus_adaptor( vmpk_SRCS
                              net.sourceforge.vmpk.xml
                              vpiano.h
                              VPiano
                              vmpk_adaptor )
    else()
        qt_add_dbus_adaptor( vmpk_SRCS
                             net.sourceforge.vmpk.xml
                             vpiano.h
                             VPiano
                             vmpk_adaptor )
    endif()
    set_property(SOURCE
        ${CMAKE_CURRENT_BINARY_DIR}/vmpk_adaptor.h
        ${CMAKE_CURRENT_BINARY_DIR}/vmpk_adaptor.cpp
        PROPERTY SKIP_AUTOGEN ON)
endif()

if(WIN32)
    configure_file (vmpk.rc.in ${CMAKE_CURRENT_BINARY_DIR}/vmpk.rc 
                    IMMEDIATE @ONLY)
endif()

if(APPLE)
    set (MACOSX_BUNDLE_INFO_STRING "Virtual MIDI Piano Keyboard" )
    set (MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION} )
    set (MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION} )
    set (MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION} )
    set (MACOSX_BUNDLE_ICON_FILE "vmpk.icns" )
    set (MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.vmpk" )
    set (MACOSX_BUNDLE_BUNDLE_NAME "vmpk" )
    set (MACOSX_BUNDLE_COPYRIGHT "© 2008-2021 Pedro López-Cabanillas and others")
    set (vmpk_RSC
        ../data/vmpk.icns
        ../data/help.html
        ../data/help_es.html
        ../data/txt2ins.awk
        ../data/gmgsxg.ins
        ../data/spanish.xml
        ../data/german.xml
        ../data/azerty.xml
        ../data/it-qwerty.xml
        ../data/vkeybd-default.xml
        ../data/pc102mac.xml
    )
    set_source_files_properties (${vmpk_RSC} PROPERTIES
        MACOSX_PACKAGE_LOCATION Resources
    )
endif()

add_executable (vmpk MACOSX_BUNDLE WIN32
    $<$<PLATFORM_ID:Darwin>:maceventhelper.mm>
    $<$<PLATFORM_ID:Windows>:${CMAKE_CURRENT_BINARY_DIR}/vmpk.rc>
    ${vmpk_SRCS}
    ${vmpk_RSC}
)

target_link_libraries(vmpk PRIVATE
    Drumstick::RT
    Drumstick::Widgets
    Qt${QT_VERSION_MAJOR}::Widgets
    $<$<BOOL:${ENABLE_DBUS}>:Qt${QT_VERSION_MAJOR}::DBus>
    $<$<BOOL:${Qt${QT_VERSION_MAJOR}X11Extras_FOUND}>:Qt${QT_VERSION_MAJOR}::X11Extras>
    $<$<BOOL:${XCB_FOUND}>:${XCB_LIBRARIES}>
)
if (QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
    target_link_libraries(vmpk PRIVATE
        Qt6::Core5Compat
    )
endif()

#$<$<PLATFORM_ID:Windows>:winmm>
#$<$<BOOL:${WIN32}>:dwmapi>

if (WIN32)
    target_link_libraries(vmpk PRIVATE
        winmm
        dwmapi)
endif()

if (APPLE)
    target_link_libraries(vmpk PRIVATE "-framework CoreFoundation -framework Cocoa")
endif()

target_include_directories(vmpk PUBLIC
    $<$<BOOL:${XCB_FOUND}>:${XCB_INCLUDE_DIRS}>
)

target_compile_definitions ( vmpk PUBLIC
    VERSION=${PROJECT_VERSION}
    RAWKBD_SUPPORT
    PALETTE_SUPPORT
    $<$<BOOL:${ENABLE_DBUS}>:ENABLE_DBUS>
)

if (DEFINED PROJECT_WC_REVISION)
    target_compile_definitions ( vmpk PRIVATE
        REVISION=${PROJECT_WC_REVISION} )
endif()

target_compile_definitions(vmpk PRIVATE
    $<$<BOOL:${EMBED_TRANSLATIONS}>:TRANSLATIONS_EMBEDDED>
)

install (TARGETS vmpk
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== debian/changelog ===
vmpk-dmo (1:0.8.4-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 29 Jun 2021 11:51:18 +0200

vmpk-dmo (1:0.8.3-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 10 May 2021 08:55:22 +0200

vmpk-dmo (1:0.8.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 31 Mar 2021 19:05:08 +0200

vmpk-dmo (1:0.8.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 21 Mar 2021 10:25:14 +0100

vmpk-dmo (1:0.8.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 31 Dec 2020 08:05:51 +0100

vmpk-dmo (1:0.7.2-dmo2) unstable; urgency=medium

  * Build against qtbase-abi-5-12-5 and/or qtdeclarative-abi-5-12-5

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 23 Oct 2019 15:12:07 +0200

vmpk-dmo (1:0.7.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 02 Sep 2019 15:43:37 +0200

vmpk-dmo (1:0.7.1-dmo3) unstable; urgency=medium

  * Should Depends on libdrumstick-rt-backends

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 23 Aug 2019 17:53:07 +0200

vmpk-dmo (1:0.7.1-dmo2) unstable; urgency=medium

  * Rebuild against new libdrumstick packages.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 22 Aug 2019 19:33:05 +0200

vmpk-dmo (1:0.7.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 04 Dec 2018 08:28:30 +0100

vmpk-dmo (1:0.7.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 03 Apr 2018 08:41:33 +0200

vmpk-dmo (1:0.6.2a-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 08 Mar 2017 08:36:32 +0100

vmpk (0.4.0-3) unstable; urgency=low

  * Revert last change that selected JACK as the RtMIDI backend
    (Reopens: 629300) (Closes: #663487).
  * Bump Standards-Version to 3.9.3, no changes needed.
  * Correctly load saved preferences (Closes: #663513).
    - add 0002-Correctly-load-saved-preferences.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 08 Jun 2012 14:41:21 +0200

vmpk (0.4.0-2) unstable; urgency=low

  * Add GenericNames entries to .desktop file (Closes: #640993).
    - add 0001-Add-GenericName-entries-to-.desktop-file.patch
  * Select JACK for the RtMIDI backend (Closes: #629300).
    - add libjack-dev in Build-Depends.

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 03 Jan 2012 23:25:35 +0100

vmpk (0.4.0-1) unstable; urgency=low

  * New upstream release.
    - remove 0001-Fix-to-build-with-ld-no-add-needed.patch
  * Bump Standards-Version to 3.9.2, no changes needed.
  * Fix copyright-refers-to-deprecated-bsd-license-file
  * Fix package-contains-empty-directory usr/share/locale/
  * Fix duplicate-changelog-files (changelog.gz vs. ChangeLog.gz)

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 03 Jan 2012 23:03:48 +0100

vmpk (0.3.3-1) unstable; urgency=low

  * New upstream release.
  * Convert to 3.0 (quilt) source format.
  * Fix FTBFS with "ld --no-add-needed" (Closes: #615793)

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 04 Mar 2011 15:03:41 +0100

vmpk (0.3.2-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards Version to 3.9.0.

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 07 Jul 2010 17:45:39 +0200

vmpk (0.3.1-1) unstable; urgency=low

  * New upstream release
  * Remove 0001-Look-for-xslproc-instead-of-libxslt, integrated upstream.
  * vmpk is linux specific (Closes: #557899)
    - Added to p-a-s

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 26 Apr 2010 12:44:41 +0200

vmpk (0.3.0-2) unstable; urgency=low

  * Build-depend on xsltproc, docbook-xsl and docbook-xml to be able to
    build the manpage and look for xslrproc instead of libxslt in
    man/CMakeLists.txt: Fixes issues when generating the manpage.
    - Add a debian/README.source

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 01 Nov 2009 14:46:38 +0100

vmpk (0.3.0-1) unstable; urgency=low

  * New upstream release
  * Add VCS-* flags
  * Update debian/copyright
  * Build-depend on debhelper (7.0.50~)
  * Bump standards to 3.8.3
  * Buil-depend on libx11-dev

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 27 Sep 2009 19:40:28 +0200

vmpk (0.2.6-1) unstable; urgency=low

  * Initial release (Closes: #522884)
  * New Upstream Version
    + Remove debian/man: integrated by upstream.
    + Remove 0001-Do-not-install-doc-packages-in-the-wrong-place.patch
      which is now integrated upstream.
    + Remove 0002-data-txt2ins.awk-should-be-executable.patch which also
      is now fixed upstream.
  * Bump standards version to 3.8.2
  * Update copyright file
  * Use my Debian address

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 06 Sep 2009 15:12:01 +0200

vmpk (0.2.5-1) unstable; urgency=low

  * Initial packaging

 -- Mehdi Dogguy <dogguy@pps.jussieu.fr>  Fri, 05 Jun 2009 23:20:54 +0200

=== debian/control ===
Source: vmpk-dmo
Section: sound
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: http://vmpk.sourceforge.net/
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13), cmake, pkg-config, xsltproc, docbook-xsl,
 docbook-xml, qttools5-dev, libdrumstick-dev (>= 1:2.3.0~), libqt5svg5-dev,
 libqt5x11extras5-dev, ninja-build, libdrumstick-rt-backends

Package: vmpk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdrumstick-rt-backends
Recommends: qjackctl, qsynth
Description: Virtual MIDI Piano Keyboard
 Virtual MIDI Piano Keyboard is a MIDI events generator and receiver. It
 doesn't produce any sound by itself, but can be used to drive a MIDI
 synthesizer (either hardware or software, internal or external). You can
 use the computer's keyboard to play MIDI notes, and also the mouse. You
 can use the Virtual MIDI Piano Keyboard to display the played MIDI notes
 from another instrument or MIDI file player.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release

override_dh_auto_test:

=== debian/watch ===
version=4

opts="uversionmangle=s/rc-win-x86|rc-win-x64|rc-macOS-x64//" \
https://sf.net/vmpk/vmpk-(.+)@ARCHIVE_EXT@

## vmpk-dmo 0.8.8

=== debian/changelog ===
vmpk-dmo (1:0.8.8-dmo2) unstable; urgency=medium

  * debian/rules add -DUSE_QT=5 option to dh_auto_configure

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 06 May 2023 16:06:43 +0200

vmpk-dmo (1:0.8.8-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 29 Aug 2022 08:37:14 +0200

vmpk-dmo (1:0.8.7-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 05 Apr 2022 01:01:55 +0200

vmpk-dmo (1:0.8.6-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 23 Dec 2021 09:10:34 +0100

vmpk-dmo (1:0.8.5-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 25 Oct 2021 14:41:06 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: optional
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
-Homepage: http://vmpk.sourceforge.net/
-Standards-Version: 4.5.1
-Build-Depends: debhelper-compat (= 13), cmake, pkg-config, xsltproc, docbook-xsl,
- docbook-xml, qttools5-dev, libdrumstick-dev (>= 1:2.3.0~), libqt5svg5-dev,
+#Homepage: https://vmpk.sourceforge.net/
+Rules-Requires-Root: no
+Standards-Version: 4.6.2
+Build-Depends: debhelper-compat (= 13), cmake, pkgconf, xsltproc, docbook-xsl,
+ docbook-xml, qttools5-dev, libdrumstick-dev (>= 1:2.7.0~), libqt5svg5-dev,
  libqt5x11extras5-dev, ninja-build, libdrumstick-rt-backends
 
 Package: vmpk

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DUSE_QT=5 \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_test:

=== debian/watch ===
version=4

https://sourceforge.net/projects/vmpk/files/vmpk/@ANY_VERSION@/ \
(?:.*)vmpk-@ANY_VERSION@@ARCHIVE_EXT@/download

## vmpk-dmo 0.9.1

=== debian/changelog ===
vmpk-dmo (1:0.9.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 25 Dec 2024 00:39:35 +0100

vmpk-dmo (1:0.9.0-dmo3+b1) unstable; urgency=medium

  * Rebuild for PAC/BTI support; no source changes.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 07 Nov 2024 08:49:49 +0100

vmpk-dmo (1:0.9.0-dmo3) unstable; urgency=medium

  * Build with Qt6 6.6

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 07 Jun 2024 10:27:43 +0200

vmpk-dmo (1:0.9.0-dmo2) unstable; urgency=medium

  * Rebuild for time_t

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 12 Mar 2024 10:00:01 +0100

vmpk-dmo (1:0.9.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 30 Dec 2023 08:50:06 +0100

vmpk-dmo (1:0.8.10-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 27 Aug 2023 13:06:40 +0200

vmpk-dmo (1:0.8.9-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 23 Jul 2023 13:16:53 +0200

vmpk-dmo (1:0.8.8-dmo3) unstable; urgency=medium

  * Build with Qt 6

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 12 Jun 2023 16:21:23 +0200

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
-#Homepage: https://vmpk.sourceforge.net/
+Homepage: https://vmpk.sourceforge.net/
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13), cmake, pkgconf, xsltproc, docbook-xsl,
- docbook-xml, qttools5-dev, libdrumstick-dev (>= 1:2.7.0~), libqt5svg5-dev,
- libqt5x11extras5-dev, ninja-build, libdrumstick-rt-backends
+ docbook-xml, libdrumstick-dev (>= 1:2.7.0~), ninja-build, libdrumstick-rt-backends,
+ qt6-base-dev, qt6-svg-dev, qt6-tools-dev
 
 Package: vmpk
 Architecture: any

## vmpk-dmo 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,24 +1,25 @@
-# Virtual MIDI Piano Keyboard
-# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 3 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License along
-# with this program; If not, see <http://www.gnu.org/licenses/>.
-
-cmake_minimum_required(VERSION 3.14)
-set(CMAKE_OSX_DEPLOYMENT_TARGET "10.12" CACHE STRING "Minimum OS X deployment version")
+#[===========================================================================[
+Virtual MIDI Piano Keyboard
+Copyright (C) 2008-2026 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License along
+with this program; If not, see <http://www.gnu.org/licenses/>.
+#]===========================================================================]
+
+cmake_minimum_required(VERSION 3.16)
 
 project( VMPK
-    VERSION 0.8.4
+    VERSION 0.9.2
     LANGUAGES CXX
     DESCRIPTION "Virtual MIDI Piano Keyboard"
     HOMEPAGE_URL "https://vmpk.sourceforge.io/"
@@ -28,20 +29,26 @@
 if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
     set(DBUS_INIT ON)
 endif()
+set(FILTER_INIT OFF)
+if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
+    set(FILTER_INIT ON)
+endif()
 option(ENABLE_DBUS "Enable VMPK DBus interface" ${DBUS_INIT})
+option(ENABLE_NATIVE_FILTER "Use a QAbstractNativeEventFilter to process raw keyboard events" ${FILTER_INIT})
 option(EMBED_TRANSLATIONS "Embed translations instead of installing" OFF)
 option(BUILD_DOCS "Build man page" ON)
+option(USE_QT5 "Prefer building with Qt5 instead of Qt6")
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_admin")
 include(SCMRevision)
 
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 # cmake bug https://gitlab.kitware.com/cmake/cmake/issues/18396 closed in cmake 3.14
-if(APPLE AND ${CMAKE_VERSION} VERSION_LESS 3.14)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
-endif()
+# if(APPLE AND ${CMAKE_VERSION} VERSION_LESS 3.14)
+#     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
+# endif()
 
 if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra") #-Wzero-as-null-pointer-constant -Wsuggest-override
@@ -51,17 +58,20 @@
 #endif()
 
 # CMAKE_SYSTEM_PROCESSOR is broken on Windows with MSVC
-# cmake bug https://gitlab.kitware.com/cmake/cmake/-/issues/15170 still open in 2021/03
+# cmake bug https://gitlab.kitware.com/cmake/cmake/-/issues/15170 still open in 2024/12
 if(MSVC)
     string(TOLOWER ${MSVC_CXX_ARCHITECTURE_ID} CMAKE_SYSTEM_PROCESSOR)
 endif()
 
-find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
-find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets Network LinguistTools REQUIRED)
-find_package(Drumstick 2.3 COMPONENTS RT Widgets REQUIRED)
-if (QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
-    find_package(Qt6 COMPONENTS Core5Compat REQUIRED)
-endif()
+if (USE_QT5)
+    find_package(QT NAMES Qt5 REQUIRED)
+    find_package(Qt5 5.9 COMPONENTS Widgets Network LinguistTools REQUIRED)
+else()
+    find_package(QT NAMES Qt6 REQUIRED)
+    find_package(Qt6 6.2 COMPONENTS Gui Widgets Network LinguistTools REQUIRED)
+endif()
+
+find_package(Drumstick 2.10 COMPONENTS RT Widgets REQUIRED)
 
 message (STATUS "VMPK v${PROJECT_VERSION}
      install prefix: ${CMAKE_INSTALL_PREFIX}
@@ -69,7 +79,8 @@
      Operating System: ${CMAKE_SYSTEM_NAME}
      System Processor: ${CMAKE_SYSTEM_PROCESSOR}
      D-Bus support: ${ENABLE_DBUS}
-     Qt5 Version: ${Qt5_VERSION}
+     Native Event Filter: ${ENABLE_NATIVE_FILTER}
+     Qt${QT_VERSION_MAJOR} Version: ${QT_VERSION}
      Drumstick Version: ${Drumstick_VERSION}"
 )
 
@@ -78,17 +89,22 @@
 endif ()
 
 if (UNIX AND NOT APPLE)
-    find_package(Qt${QT_VERSION_MAJOR}X11Extras REQUIRED)
-    find_package(PkgConfig REQUIRED)
-    if(PKG_CONFIG_FOUND)
-        message(STATUS "Program pkg-config v${PKG_CONFIG_VERSION_STRING} found (${PKG_CONFIG_EXECUTABLE})")
-    else()
-        message(FATAL_ERROR "Program pkg-config not found")
+    if (ENABLE_NATIVE_FILTER)
+        if (QT_VERSION VERSION_LESS 6.0.0)
+            find_package(Qt5X11Extras REQUIRED)
+        endif()
+        find_package(PkgConfig REQUIRED)
+        if(PKG_CONFIG_FOUND)
+            message(STATUS "Program pkg-config v${PKG_CONFIG_VERSION_STRING} found (${PKG_CONFIG_EXECUTABLE})")
+        else()
+            message(FATAL_ERROR "Program pkg-config not found")
+        endif()
+        pkg_check_modules(XCB REQUIRED xcb)
+        if(XCB_FOUND)
+            message(STATUS "Found XCB development libs v${XCB_VERSION}")
+        endif()
     endif()
-    pkg_check_modules(XCB REQUIRED xcb)
-    if(XCB_FOUND)
-        message(STATUS "Found XCB development libs v${XCB_VERSION}")
-    endif()
+
     include(GNUInstallDirs)
 endif()
 
@@ -103,7 +119,9 @@
     data/help_es.html
     data/help_ru.html
     data/help_sr.html
+    data/help_zh_CN.html
     data/azerty.xml
+    data/azerty-FR.xml
     data/german.xml
     data/it-qwerty.xml
     data/pc102mac.xml
@@ -132,9 +150,9 @@
         COMMAND cp -r src vmpk-${PROJECT_VERSION}
         COMMAND cp -r man vmpk-${PROJECT_VERSION}
         COMMAND cp -r dbus vmpk-${PROJECT_VERSION}
-        COMMAND cp translations/vmpk_{cs,de,es,fr,gl,ru,sr,sv}.ts vmpk-${PROJECT_VERSION}/translations/
+        COMMAND cp translations/vmpk_{cs,de,es,fr,gl,it,ru,sr,sv,zh_CN}.ts vmpk-${PROJECT_VERSION}/translations/
         COMMAND cp translations/CMakeLists.txt vmpk-${PROJECT_VERSION}/translations/
-        COMMAND cp AUTHORS ChangeLog CMakeLists.txt COPYING gpl.rtf NEWS README.md TODO *.nsi *.nsi.in net.sourceforge.VMPK.desktop net.sourceforge.VMPK.appdata.xml vmpk.pro *.pri vmpk.spec.in qt.conf vmpk-${PROJECT_VERSION}
+        COMMAND cp AUTHORS ChangeLog CMakeLists.txt COPYING gpl.rtf NEWS README.md TODO *.nsi *.nsi.in net.sourceforge.VMPK.desktop net.sourceforge.VMPK.metainfo.xml vmpk.pro *.pri vmpk.spec.in qt.conf vmpk-${PROJECT_VERSION}
         COMMAND tar -cj --exclude=.* -f vmpk-${PROJECT_VERSION}.tar.bz2 vmpk-${PROJECT_VERSION}
         COMMAND tar -cz --exclude=.* -f vmpk-${PROJECT_VERSION}.tar.gz vmpk-${PROJECT_VERSION}
         COMMAND zip -qr vmpk-${PROJECT_VERSION}.zip vmpk-${PROJECT_VERSION} -x '.[a-z]*'
@@ -178,7 +196,7 @@
     install (FILES net.sourceforge.VMPK.desktop
              DESTINATION ${CMAKE_INSTALL_DATADIR}/applications )
 
-    install (FILES net.sourceforge.VMPK.appdata.xml
+    install (FILES net.sourceforge.VMPK.metainfo.xml
              DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo )
 
      # uninstall custom target
@@ -188,17 +206,17 @@
          IMMEDIATE @ONLY)
      add_custom_target( uninstall
          "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
-endif ()
-
-if(WIN32)
-    include (InstallRequiredSystemLibraries)
-	install (FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS} 
-			 DESTINATION .)
-    install (FILES ${vmpk_DATA_FILES}
-             DESTINATION .)
-	set(FLUIDSYNTH_PREFIX $ENV{FLUIDSYNTH})
-    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup-msvc2019.nsi.in
-        ${CMAKE_CURRENT_BINARY_DIR}/setup-msvc2019.nsi IMMEDIATE @ONLY)
+else()
+    if(WIN32)
+        include (InstallRequiredSystemLibraries)
+        install (FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS}
+                 DESTINATION .)
+        install (FILES ${vmpk_DATA_FILES}
+                 DESTINATION .)
+        set(FLUIDSYNTH_PREFIX $ENV{FLUIDSYNTH})
+        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup-msvc2022.nsi.in
+            ${CMAKE_CURRENT_BINARY_DIR}/setup-msvc2022.nsi IMMEDIATE @ONLY)
+    endif()
 endif()
 
 # CPack support

=== man/CMakeLists.txt ===
#[===========================================================================[
Virtual MIDI Piano Keyboard
Copyright (C) 2008-2026 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

if (BUILD_DOCS)
    find_program(XSLTPROC_EXECUTABLE xsltproc)
endif()

if (XSLTPROC_EXECUTABLE)
    message(STATUS "XSLTPROC Found: ${XSLTPROC_EXECUTABLE}")
    include(CreateManpages)
    create_manpages(vmpk.xml)
else()
    install( FILES vmpk.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 )
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,20 @@
-# Virtual MIDI Piano Keyboard
-# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 3 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License along 
-# with this program; If not, see <http://www.gnu.org/licenses/>.
+#[===========================================================================[
+  Virtual MIDI Piano Keyboard
+  Copyright (C) 2008-2026 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 3 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License along
+  with this program; If not, see <http://www.gnu.org/licenses/>.
+#]===========================================================================]
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
@@ -26,9 +28,11 @@
          ../translations/vmpk_es.ts
          ../translations/vmpk_fr.ts
          ../translations/vmpk_gl.ts
+         ../translations/vmpk_it.ts
          ../translations/vmpk_ru.ts
          ../translations/vmpk_sr.ts
          ../translations/vmpk_sv.ts
+         ../translations/vmpk_zh_CN.ts
     )
     if (QT_VERSION VERSION_LESS 5.15.0)
         qt5_add_translation(QM_FILES ${TRANSLATIONS})
@@ -41,7 +45,7 @@
     file(GLOB WIDGETS_TRANS "${DRUMSTICK_PREFIX}/share/drumstick/drumstick-widgets_*.qm")
     file(COPY ${WIDGETS_TRANS} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
     add_app_translations_resource(APP_RES ${QM_FILES} ${WIDGETS_TRANS})
-    add_qt_translations_resource(QT_RES cs de es fr gl ru sr sv)
+    add_qt_translations_resource(QT_RES cs de es fr gl it ru sr sv zh_CN)
 endif()
 
 set(vmpk_SRCS
@@ -63,21 +67,20 @@
     constants.h
     extracontrols.cpp
     extracontrols.h
+    iconutils.cpp
+    iconutils.h
     instrument.cpp
     instrument.h
     keyboardmap.cpp
     keyboardmap.h
     kmapdialog.cpp
     kmapdialog.h
-    maceventhelper.h
     main.cpp
     mididefs.h
     midisetup.cpp
     midisetup.h
     preferences.cpp
     preferences.h
-    nativefilter.cpp
-    nativefilter.h
     riff.cpp
     riff.h
     riffimportdlg.cpp
@@ -93,9 +96,22 @@
     ${QT_RES}
 )
 
+if (ENABLE_NATIVE_FILTER)
+    list(APPEND vmpk_SRCS
+        nativefilter.cpp
+        nativefilter.h
+    )
+    if (APPLE)
+        list(APPEND vmpk_SRCS
+            maceventhelper.mm
+            maceventhelper.h
+        )
+    endif()
+endif()
+
 if(WIN32)
     include(CheckCXXSourceCompiles)
-    check_cxx_source_compiles("#include <Windows.h>
+    check_cxx_source_compiles("#include <windows.h>
         int main() { EnumWindows([](HWND, LPARAM) -> BOOL { return true; }, 0); return 0; }"
         COMPILER_SUPPORTED)
     if (NOT COMPILER_SUPPORTED)
@@ -105,7 +121,6 @@
 endif()
 
 if(ENABLE_DBUS)
-    add_definitions(-DENABLE_DBUS)
     if (QT_VERSION VERSION_LESS 5.15.0)
         qt5_add_dbus_adaptor( vmpk_SRCS
                               net.sourceforge.vmpk.xml
@@ -126,7 +141,7 @@
 endif()
 
 if(WIN32)
-    configure_file (vmpk.rc.in ${CMAKE_CURRENT_BINARY_DIR}/vmpk.rc 
+    configure_file (vmpk.rc.in ${CMAKE_CURRENT_BINARY_DIR}/vmpk.rc
                     IMMEDIATE @ONLY)
 endif()
 
@@ -138,7 +153,7 @@
     set (MACOSX_BUNDLE_ICON_FILE "vmpk.icns" )
     set (MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.vmpk" )
     set (MACOSX_BUNDLE_BUNDLE_NAME "vmpk" )
-    set (MACOSX_BUNDLE_COPYRIGHT "© 2008-2021 Pedro López-Cabanillas and others")
+    set (MACOSX_BUNDLE_COPYRIGHT "© 2008-2026 Pedro López-Cabanillas and others")
     set (vmpk_RSC
         ../data/vmpk.icns
         ../data/help.html
@@ -158,7 +173,6 @@
 endif()
 
 add_executable (vmpk MACOSX_BUNDLE WIN32
-    $<$<PLATFORM_ID:Darwin>:maceventhelper.mm>
     $<$<PLATFORM_ID:Windows>:${CMAKE_CURRENT_BINARY_DIR}/vmpk.rc>
     ${vmpk_SRCS}
     ${vmpk_RSC}
@@ -169,17 +183,13 @@
     Drumstick::Widgets
     Qt${QT_VERSION_MAJOR}::Widgets
     $<$<BOOL:${ENABLE_DBUS}>:Qt${QT_VERSION_MAJOR}::DBus>
-    $<$<BOOL:${Qt${QT_VERSION_MAJOR}X11Extras_FOUND}>:Qt${QT_VERSION_MAJOR}::X11Extras>
+    $<$<BOOL:${Qt5X11Extras_FOUND}>:Qt5::X11Extras>
     $<$<BOOL:${XCB_FOUND}>:${XCB_LIBRARIES}>
 )
+
 if (QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
-    target_link_libraries(vmpk PRIVATE
-        Qt6::Core5Compat
-    )
-endif()
-
-#$<$<PLATFORM_ID:Windows>:winmm>
-#$<$<BOOL:${WIN32}>:dwmapi>
+    target_link_libraries(vmpk PRIVATE Qt6::Gui)
+endif()
 
 if (WIN32)
     target_link_libraries(vmpk PRIVATE
@@ -200,6 +210,7 @@
     RAWKBD_SUPPORT
     PALETTE_SUPPORT
     $<$<BOOL:${ENABLE_DBUS}>:ENABLE_DBUS>
+    $<$<BOOL:${ENABLE_NATIVE_FILTER}>:ENABLE_NATIVE_FILTER>
 )
 
 if (DEFINED PROJECT_WC_REVISION)
@@ -211,7 +222,12 @@
     $<$<BOOL:${EMBED_TRANSLATIONS}>:TRANSLATIONS_EMBEDDED>
 )
 
-install (TARGETS vmpk
-    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-    BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR}
-)
+if (UNIX AND NOT APPLE)
+    install (TARGETS vmpk
+        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+        BUNDLE DESTINATION ~/Applications
+    )
+else()
+    set(DEPLOYMENT_TARGET vmpk)
+    include(DeploymentUtils)
+endif()

=== debian/changelog ===
vmpk-dmo (1:0.9.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 06 Jan 2026 16:29:57 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,9 @@
 Source: vmpk-dmo
 Section: sound
-Priority: optional
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://vmpk.sourceforge.net/
-Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Build-Depends: debhelper-compat (= 13), cmake, pkgconf, xsltproc, docbook-xsl,
  docbook-xml, libdrumstick-dev (>= 1:2.7.0~), ninja-build, libdrumstick-rt-backends,
  qt6-base-dev, qt6-svg-dev, qt6-tools-dev

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DUSE_QT=6 \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_test:

=== debian/watch ===
version=4

https://sf.net/vmpk/ vmpk-@ANY_VERSION@@ARCHIVE_EXT@
